print "Initializing..."
from AppKit import NSSpeechSynthesizer
import random, numpy
allPhonemes = "%", "@", "AE", "EY", "AO", "AX", "IY", "EH", "IH", "AY", "IX", "AA", "UW", "UH", "UX", "OW", "AW", "OY", "b", "C", "d", "D", "f", "g", "h", "J", "k", "l", "m", "n", "N", "p", "r", "s", "S", "t", "T", "v", "w", "y", "z", "Z"

synthesizer = NSSpeechSynthesizer.alloc().initWithVoice_(NSSpeechSynthesizer.defaultVoice())
fin = open("/Users/impiaaa/Downloads/oliver twist.txt")
catalog = {}
endings = []
starts = []
lengths = []

print "Reading and speaking..."
phonemeStr = synthesizer.phonemesFromText_(fin.read())
fin.close()

print "Cataloging..."
for word in phonemeStr.split():
    splitWord = []
    i = 0
    while i < len(word):
        if word[i] in allPhonemes:
            p = word[i]
            i += 1
        elif word[i:i+2] in allPhonemes:
            p = word[i:i+2]
            i += 2
        else:
            i += 1
            continue
        splitWord.append(p)

    i = 0
    starts.append(splitWord[i])
    while i < len(splitWord)-1:
        p = splitWord[i]
        next = splitWord[i+1]
        if p in catalog:
            catalog[p].append(next)
        else:
            catalog[p] = [next]
        i += 1
    endings.append(next)
    lengths.append(len(splitWord))
avgLen = numpy.average(lengths)
stdDev = numpy.std(lengths)

print "Synthesizing..."
while True:
    s = ''
    c = random.choice(starts)
    s += c
    for i in range(int(random.gauss(avgLen, stdDev)+0.5)-2):
        # +0.5 b/c int rounds down
        # -2 because we need extra room to end nicely (see below)
        if c in catalog:
            c = random.choice(catalog[c])
        else:
            c = random.choice(catalog.keys())
        s += c
    while c not in endings:
        # end with a character that makes sense
        if c in catalog:
            c = random.choice(catalog[c])
        else:
            c = random.choice(catalog.keys())
        s += c
    synthesizer.startSpeakingString_("[[inpt PHON]]"+s)
    raw_input(s)
